#!/usr/bin/env bash
hostname=$(sudo hostname)
NODES=$(head -n 1 /home/akkadianuser/load_balancer.config)

ran=$(( ( RANDOM % 100 )  + 1 ))

if [[ -d /opt/akkadian/aco-server ]]; then
    gpg -d -q --batch --passphrase Akkadian /home/akkadianuser/.sshpassword_aco.gpg > /home/akkadianuser/.sshpass_$ran
else
    gpg -d -q --batch --passphrase Akkadian /home/akkadianuser/.sshpassword_pme_cm.gpg > /home/akkadianuser/.sshpass_$ran
fi
IFS=$' '
nodes_comma_separated=$(echo ${NODES// /,})
nodes_comma_separated=$(echo "${nodes_comma_separated:1}")
echo "nodes: $nodes_comma_separated"
#ensure the change between replication is when there are more than 1 up and running
nodes_len=0
for j in $NODES
    do
        if [[ ( "$j" != "[" ) && ( "$j" != "]" ) ]]
        then
            sshpass -f /home/akkadianuser/.sshpass_$ran ssh -o StrictHostKeyChecking=no root@$j "sh /home/akkadianuser/scripts/ha/replication_new_galera_approach/modify_local_cnf.sh $nodes_comma_separated $j"
        fi
done

#somenode has to be the master, seach who is the one
for j in $NODES
    do
        if [[ ( "$j" != "[" ) && ( "$j" != "]" ) ]]
        then
            sshpass -f /home/akkadianuser/.sshpass_$ran ssh -o StrictHostKeyChecking=no root@$j "sudo galera_new_cluster"
        fi
done

#no matter if node was already initialized with galera_new_cluster, it will work and reduces the complexity
for j in $NODES
    do
        if [[ ( "$j" != "[" ) && ( "$j" != "]" ) ]]
        then
            sshpass -f /home/akkadianuser/.sshpass_$ran ssh -o StrictHostKeyChecking=no root@$j "sudo systemctl start mariadb"
        fi
done